//+------------------------------------------------------------------+
//|                                                    simple EA.mq4 |
//|                                     Copyright  2011, luktom.biz |
//|                                                www.luktom.biz/en |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, luktom.biz."
#property link      "http://www.luktom.biz"


extern double stopLoss = 300.0;
extern double takeProfit = 500.0;
extern string Begin="2:00";
extern string End="10:00";
extern double distance = 60;
bool isECN = true; 
bool cond  = false;
bool cond2 = false;
double low;
double high;
extern double lots = 0.1;
int magic = 1232344524285020;
int slippage = 1;
string comment = "";
int ticket;
int short = 0;
int long = 0; 


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
    Print(countOrders(magic,OP_BUY));
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
  Print(AccountCurrency());
//----
 
   if(isGoodTime(Begin,End))
   {
      short = 0; 
      long = 0;
    
      if(!cond)
      {
        low = Bid;
        high = Ask; 
      }
    cond = true; 
    
   if(Bid < low) low = Bid; 
   if(Ask > high) high = Ask;
        
          
   }
   
   if((high - low)*1000>distance)
   {
    cond2 = true;   
   }
   if(!isGoodTime(Begin,End))
   {
      
      cond = false;
   }
 
   if(!isGoodTime(Begin,End) && cond2)
   {
     
     if(countOrders(magic,OP_SELL) == 0 )
     {
       if(Bid<=(low-0.0005) && short == 0)
       {
        short++;
        if(isECN == false)
        {
        OrderSend(Symbol(),OP_SELL,lots,Bid, slippage,sltpValue(Ask+ stopLoss*Point,stopLoss) ,sltpValue(Ask- takeProfit*Point,takeProfit),comment,magic);  
        }
        if(isECN)
        {
         ticket=OrderSend(Symbol(),OP_SELL,lots,Bid, slippage,0,0,comment,magic);
         OrderSelect(ticket,SELECT_BY_TICKET);
         OrderModify(ticket,OrderOpenPrice(),sltpValue(Ask +stopLoss*Point, stopLoss),sltpValue(Bid- takeProfit*Point,takeProfit),0);
        }
       }
     }
     if(countOrders(magic,OP_BUY) == 0)
     {
  
      if((Ask-high)>=0.005 && long ==0)
       {
       long++;
       if(isECN==false)
       {
          OrderSend(Symbol(),OP_BUY,lots,Ask, slippage,sltpValue(Ask - stopLoss*Point, stopLoss),sltpValue(Bid+ takeProfit*Point,takeProfit),comment,magic);
       }
       if(isECN)
       {
         ticket=OrderSend(Symbol(),OP_BUY,lots,Ask, slippage,0,0,comment,magic);
         OrderSelect(ticket,SELECT_BY_TICKET);
         OrderModify(ticket,OrderOpenPrice(),sltpValue(Bid - stopLoss*Point, stopLoss),sltpValue(Ask+ takeProfit*Point,takeProfit),0);
       }
       }
     }
       
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+
bool isGoodTime(string Begin, string End) {

    if(TimeCurrent()>StrToTime(Begin) && TimeCurrent()<StrToTime(End)) {
        return(true);
    }

    return(false);
}

int countOrders(int oMagic,int oType) {

   int count=0;
 
   for(int i=0;i<OrdersTotal();i++) {
    if(OrderSelect(i,SELECT_BY_POS)) {
     if(OrderMagicNumber()==oMagic) {
      if(OrderSymbol()==Symbol()) {
       if(OrderType()==oType || oType<0) {
        count++;
        }
       }
      }
     }
    }
   
   
   return(count);
 
}

double sltpValue(double w1, int w2)
{
   if(w2 == 0)
   return (0);
   return (NormalizeDouble(w1, Digits));
}